import React from "react";
import { useFuse } from "./hooks/useFuse";
import { FuzzyInputProvider } from "./hooks/useFuzzyInput";
import { FuzzyResultProvider } from "./hooks/useFuzzyResult";
import FuzzyGui from "./FuzzyGui";
// fuse specific default option
var optionsDefault = {
    //includeMatches: true,
    ignoreLocation: true,
    ignoreFieldNorm: false,
    includeScore: true,
    keys: ["label", "txt", "tags"]
};
//default options for mark.js
var markOptionsDefault = {
    element: "b",
    accuracy: "complementary",
    exclude: ["h5"],
};
var ZIMFuzzySearch = function (_a) {
    var data = _a.data, tagConceptMap = _a.tagConceptMap, onSelect = _a.onSelect, searchInput = _a.searchInput, _b = _a.placeHolder, placeHolder = _b === void 0 ? "Search..." : _b, setSearchInput = _a.setSearchInput, _c = _a.fuseOptions, fuseOptions = _c === void 0 ? optionsDefault : _c, _d = _a.markOptions, markOptions = _d === void 0 ? markOptionsDefault : _d, _e = _a.resultCountLabel, resultCountLabel = _e === void 0 ? "Matches: " : _e, _f = _a.searchOnClick, searchOnClick = _f === void 0 ? false : _f, children = _a.children;
    var _g = useFuse(fuseOptions, data), fuseResult = _g.fuseResult, doFuseSearch = _g.doFuseSearch, groupBy = _g.groupBy, resetFuse = _g.resetFuse;
    var _h = React.useState(searchInput ? searchInput : null), inputVal = _h[0], setInputVal = _h[1];
    var fuseSearchInputDelay = React.useRef(undefined);
    // two way binding
    React.useEffect(function () {
        if (!searchInput)
            return;
        setInputVal(searchInput);
    }, [searchInput]);
    // when input change do search when not in clickmode.
    // timer delays init auf fusesearch(e.g. if multiple inputs)
    React.useEffect(function () {
        if (fuseSearchInputDelay.current)
            clearTimeout(fuseSearchInputDelay.current);
        if (!searchOnClick && inputVal) {
            fuseSearchInputDelay.current = setTimeout(function () {
                if (fuseSearchInputDelay.current) {
                    console.log("DO SEARCH!");
                    doFuseSearch(inputVal);
                }
            }, 300);
        }
        else if (inputVal === null) {
            resetFuse();
        }
    }, [inputVal, data, doFuseSearch, searchOnClick, resetFuse]);
    var handleInput = function (val) {
        setInputVal(val);
        // ensure two way binding
        if (setSearchInput)
            setSearchInput(val);
    };
    return (React.createElement(FuzzyInputProvider, { clickMode: searchOnClick, doSearch: doFuseSearch, handleInput: handleInput, inputVal: inputVal, placeHolder: placeHolder, data: data },
        React.createElement(FuzzyResultProvider, { fuzzyResult: fuseResult, onSelect: onSelect, resultCountLabel: resultCountLabel, tagConceptMap: tagConceptMap }, children ? children : React.createElement(FuzzyGui, { markOptions: markOptions }))));
};
export default ZIMFuzzySearch;
